]> Git Repo - J-u-boot.git/blame - MAKEALL
MAKEALL: Fix kill_children
[J-u-boot.git] / MAKEALL
CommitLineData
f2352877 1#!/bin/bash
0777eafb
WD
2# Tool mainly for U-Boot Quality Assurance: build one or more board
3# configurations with minimal verbosity, showing only warnings and
4# errors.
0777eafb 5
d8e392d9
MF
6usage()
7{
8 # if exiting with 0, write to stdout, else write to stderr
9 local ret=${1:-0}
10 [ "${ret}" -eq 1 ] && exec 1>&2
11 cat <<-EOF
12 Usage: MAKEALL [options] [--] [boards-to-build]
13
14 Options:
15 -a ARCH, --arch ARCH Build all boards with arch ARCH
16 -c CPU, --cpu CPU Build all boards with cpu CPU
17 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
18 -s SOC, --soc SOC Build all boards with soc SOC
7f79c6f2 19 -l, --list List all targets to be built
9b96c6b1
MV
20 -m, --maintainers List all targets and maintainer email
21 -M, --mails List all targets and all affilated emails
33f336d5 22 -C, --check Enable build checking
d8e392d9
MF
23 -h, --help This help output
24
25 Selections by these options are logically ANDed; if the same option
26 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
27 will select all configurations where the vendor is either FOO or
28 BAR. Any additional arguments specified on the command line are
29 always build additionally. See the boards.cfg file for more info.
30
31 If no boards are specified, then the default is "powerpc".
32
33 Environment variables:
34 BUILD_NCPUS number of parallel make jobs (default: auto)
35 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
36 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
37 BUILD_DIR output build directory (default: ./)
f588bb03 38 BUILD_NBUILDS number of parallel targets (default: 1)
d8e392d9
MF
39
40 Examples:
41 - build all Power Architecture boards:
42 MAKEALL -a powerpc
43 MAKEALL --arch powerpc
44 MAKEALL powerpc
45 - build all PowerPC boards manufactured by vendor "esd":
46 MAKEALL -a powerpc -v esd
47 - build all PowerPC boards manufactured either by "keymile" or "siemens":
48 MAKEALL -a powerpc -v keymile -v siemens
49 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
50 MAKEALL -c mpc83xx -v freescale 4xx
51 EOF
52 exit ${ret}
53}
54
33f336d5
KP
55SHORT_OPTS="ha:c:v:s:lmMC"
56LONG_OPTS="help,arch:,cpu:,vendor:,soc:,list,maintainers,mails,check"
0777eafb
WD
57
58# Option processing based on util-linux-2.13/getopt-parse.bash
59
071bc923 60# Note that we use `"$@"' to let each command-line parameter expand to a
0777eafb
WD
61# separate word. The quotes around `$@' are essential!
62# We need TEMP as the `eval set --' would nuke the return value of
63# getopt.
64TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
65 -n 'MAKEALL' -- "$@"`
66
d8e392d9 67[ $? != 0 ] && usage 1
0777eafb
WD
68
69# Note the quotes around `$TEMP': they are essential!
70eval set -- "$TEMP"
71
72SELECTED=''
7f79c6f2 73ONLY_LIST=''
9b96c6b1
MV
74PRINT_MAINTS=''
75MAINTAINERS_ONLY=''
0777eafb
WD
76
77while true ; do
78 case "$1" in
79 -a|--arch)
80 # echo "Option ARCH: argument \`$2'"
81 if [ "$opt_a" ] ; then
82 opt_a="${opt_a%)} || \$2 == \"$2\")"
83 else
84 opt_a="(\$2 == \"$2\")"
85 fi
86 SELECTED='y'
87 shift 2 ;;
88 -c|--cpu)
89 # echo "Option CPU: argument \`$2'"
90 if [ "$opt_c" ] ; then
aa2e279d 91 opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
0777eafb 92 else
aa2e279d 93 opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
0777eafb
WD
94 fi
95 SELECTED='y'
96 shift 2 ;;
97 -s|--soc)
98 # echo "Option SoC: argument \`$2'"
99 if [ "$opt_s" ] ; then
100 opt_s="${opt_s%)} || \$6 == \"$2\")"
101 else
102 opt_s="(\$6 == \"$2\")"
103 fi
104 SELECTED='y'
105 shift 2 ;;
106 -v|--vendor)
107 # echo "Option VENDOR: argument \`$2'"
108 if [ "$opt_v" ] ; then
109 opt_v="${opt_v%)} || \$5 == \"$2\")"
110 else
111 opt_v="(\$5 == \"$2\")"
112 fi
113 SELECTED='y'
114 shift 2 ;;
33f336d5
KP
115 -C|--check)
116 CHECK='C=1'
117 shift ;;
7f79c6f2
MV
118 -l|--list)
119 ONLY_LIST='y'
120 shift ;;
9b96c6b1
MV
121 -m|--maintainers)
122 ONLY_LIST='y'
123 PRINT_MAINTS='y'
124 MAINTAINERS_ONLY='y'
125 shift ;;
126 -M|--mails)
127 ONLY_LIST='y'
128 PRINT_MAINTS='y'
129 shift ;;
d8e392d9
MF
130 -h|--help)
131 usage ;;
0777eafb
WD
132 --)
133 shift ; break ;;
134 *)
135 echo "Internal error!" >&2 ; exit 1 ;;
136 esac
137done
138# echo "Remaining arguments:"
139# for arg do echo '--> '"\`$arg'" ; done
140
141FILTER="\$1 !~ /^#/"
142[ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
143[ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
144[ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
145[ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
146
147if [ "$SELECTED" ] ; then
148 SELECTED=$(awk '('"$FILTER"') { print $1 }' boards.cfg)
cd57b0bb
PT
149
150 # Make sure some boards from boards.cfg are actually found
151 if [ -z "$SELECTED" ] ; then
152 echo "Error: No boards selected, invalid arguments"
153 exit 1
154 fi
0777eafb
WD
155fi
156
157#########################################################################
158
40a28f08
PT
159# Print statistics when we exit
160trap exit 1 2 3 15
161trap print_stats 0
162
7fa6a2f3
WD
163# Determine number of CPU cores if no default was set
164: ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
165
166if [ "$BUILD_NCPUS" -gt 1 ]
167then
55f786d8 168 JOBS="-j $((BUILD_NCPUS + 1))"
7fa6a2f3
WD
169else
170 JOBS=""
171fi
172
a8c7c708 173
7ebf7443
WD
174if [ "${CROSS_COMPILE}" ] ; then
175 MAKE="make CROSS_COMPILE=${CROSS_COMPILE}"
176else
177 MAKE=make
178fi
179
f9328639
MB
180if [ "${MAKEALL_LOGDIR}" ] ; then
181 LOG_DIR=${MAKEALL_LOGDIR}
182else
183 LOG_DIR="LOG"
184fi
887e2ec9 185
f588bb03
AF
186: ${BUILD_NBUILDS:=1}
187BUILD_MANY=0
188
189if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
190 BUILD_MANY=1
191 : ${BUILD_DIR:=./build}
192 mkdir -p "${BUILD_DIR}/ERR"
193 find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
f9328639
MB
194fi
195
f588bb03
AF
196: ${BUILD_DIR:=.}
197
198OUTPUT_PREFIX="${BUILD_DIR}"
199
200[ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
201find "${LOG_DIR}/" -type f -exec rm -f {} +
7ebf7443
WD
202
203LIST=""
204
40a28f08
PT
205# Keep track of the number of builds and errors
206ERR_CNT=0
207ERR_LIST=""
b86a475c
JH
208WRN_CNT=0
209WRN_LIST=""
40a28f08 210TOTAL_CNT=0
f588bb03
AF
211CURRENT_CNT=0
212OLDEST_IDX=1
f2352877 213RC=0
40a28f08 214
9ec49f8f
MF
215# Helper funcs for parsing boards.cfg
216boards_by_field()
217{
aa2e279d
AM
218 FS="[ \t]+"
219 [ -n "$3" ] && FS="$3"
9ec49f8f
MF
220 awk \
221 -v field="$1" \
222 -v select="$2" \
aa2e279d 223 -F "$FS" \
9ec49f8f
MF
224 '($1 !~ /^#/ && $field == select) { print $1 }' \
225 boards.cfg
226}
227boards_by_arch() { boards_by_field 2 "$@" ; }
aa2e279d 228boards_by_cpu() { boards_by_field 3 "$@" "[: \t]+" ; }
0a41edaa 229boards_by_soc() { boards_by_field 6 "$@" ; }
9ec49f8f 230
0db5bca8
WD
231#########################################################################
232## MPC5xx Systems
233#########################################################################
234
9ec49f8f 235LIST_5xx="$(boards_by_cpu mpc5xx)"
0db5bca8 236
945af8d7
WD
237#########################################################################
238## MPC5xxx Systems
239#########################################################################
240
2ae18241 241LIST_5xxx="$(boards_by_cpu mpc5xxx)"
945af8d7 242
8993e54b
RJ
243#########################################################################
244## MPC512x Systems
245#########################################################################
246
2ae18241 247LIST_512x="$(boards_by_cpu mpc512x)"
945af8d7 248
7ebf7443
WD
249#########################################################################
250## MPC8xx Systems
251#########################################################################
9ec49f8f 252
2ae18241 253LIST_8xx="$(boards_by_cpu mpc8xx)"
7ebf7443
WD
254
255#########################################################################
256## PPC4xx Systems
257#########################################################################
258
2ae18241 259LIST_4xx="$(boards_by_cpu ppc4xx)"
7ebf7443 260
983fda83
WD
261#########################################################################
262## MPC8220 Systems
263#########################################################################
264
9ec49f8f 265LIST_8220="$(boards_by_cpu mpc8220)"
983fda83 266
7ebf7443
WD
267#########################################################################
268## MPC824x Systems
269#########################################################################
270
2ae18241 271LIST_824x="$(boards_by_cpu mpc824x)"
592c5cab 272
7ebf7443 273#########################################################################
7aa78614 274## MPC8260 Systems (includes 8250, 8255 etc.)
7ebf7443
WD
275#########################################################################
276
2ae18241 277LIST_8260="$(boards_by_cpu mpc8260)"
7ebf7443 278
f046ccd1
EL
279#########################################################################
280## MPC83xx Systems (includes 8349, etc.)
281#########################################################################
282
2ae18241 283LIST_83xx="$(boards_by_cpu mpc83xx)"
f046ccd1 284
42d1f039
WD
285#########################################################################
286## MPC85xx Systems (includes 8540, 8560 etc.)
287#########################################################################
288
2ae18241 289LIST_85xx="$(boards_by_cpu mpc85xx)"
42d1f039 290
822d5536
JL
291#########################################################################
292## MPC86xx Systems
293#########################################################################
294
2ae18241 295LIST_86xx="$(boards_by_cpu mpc86xx)"
822d5536 296
7ebf7443
WD
297#########################################################################
298## 74xx/7xx Systems
299#########################################################################
300
2ae18241 301LIST_74xx_7xx="$(boards_by_cpu 74xx_7xx)"
7ebf7443 302
d9a42c0a
WD
303#########################################################################
304## PowerPC groups
305#########################################################################
306
307LIST_TSEC=" \
308 ${LIST_83xx} \
309 ${LIST_85xx} \
310 ${LIST_86xx} \
311"
312
a47a12be 313LIST_powerpc=" \
fb56579f 314 ${LIST_5xx} \
3deca9d4 315 ${LIST_512x} \
fb56579f
KP
316 ${LIST_5xxx} \
317 ${LIST_8xx} \
318 ${LIST_8220} \
319 ${LIST_824x} \
320 ${LIST_8260} \
321 ${LIST_83xx} \
322 ${LIST_85xx} \
323 ${LIST_86xx} \
324 ${LIST_4xx} \
2ae18241 325 ${LIST_74xx_7xx}\
fb56579f 326"
7ebf7443 327
a47a12be
SR
328# Alias "ppc" -> "powerpc" to not break compatibility with older scripts
329# still using "ppc" instead of "powerpc"
330LIST_ppc=" \
331 ${LIST_powerpc} \
332"
333
7ebf7443
WD
334#########################################################################
335## StrongARM Systems
336#########################################################################
337
9ec49f8f 338LIST_SA="$(boards_by_cpu sa1100)"
7ebf7443 339
cce5d210
AM
340#########################################################################
341## ARM7 Systems
342#########################################################################
343
344LIST_ARM7="$(boards_by_cpu arm720t)"
345
7ebf7443
WD
346#########################################################################
347## ARM9 Systems
348#########################################################################
349
6a8760d7
WD
350LIST_ARM9="$(boards_by_cpu arm920t) \
351 $(boards_by_cpu arm926ejs) \
352 $(boards_by_cpu arm925t) \
cce5d210 353 $(boards_by_cpu arm946es) \
6f21347d 354"
7ebf7443 355
8ed96046
WD
356#########################################################################
357## ARM11 Systems
358#########################################################################
cce5d210
AM
359LIST_ARM11="$(boards_by_cpu arm1136) \
360 $(boards_by_cpu arm1176) \
361"
8ed96046 362
f904cdbb 363#########################################################################
f56348af 364## ARMV7 Systems
f904cdbb 365#########################################################################
f37586bb
DB
366
367LIST_ARMV7="$(boards_by_cpu armv7)"
f904cdbb 368
602cac13
JCPV
369#########################################################################
370## AT91 Systems
371#########################################################################
372
5cfeec51 373LIST_at91="$(boards_by_soc at91)"
602cac13 374
7ebf7443
WD
375#########################################################################
376## Xscale Systems
377#########################################################################
378
7c957c0e 379LIST_pxa="$(boards_by_cpu pxa)"
7ebf7443 380
bb1c01ea 381LIST_ixp="$(boards_by_cpu ixp)"
7ebf7443 382
24dede48
SR
383#########################################################################
384## SPEAr Systems
385#########################################################################
386
387LIST_spear="$(boards_by_soc spear)"
388
d9a42c0a
WD
389#########################################################################
390## ARM groups
391#########################################################################
2d5b561e 392
cce5d210 393LIST_arm="$(boards_by_arch arm)"
7ebf7443 394
c021880a 395#########################################################################
b62bdffb 396## MIPS Systems (default = big endian)
c021880a
WD
397#########################################################################
398
fb56579f
KP
399LIST_mips4kc=" \
400 incaip \
cce5d210
AM
401 incaip_100MHz \
402 incaip_133MHz \
403 incaip_150MHz \
0764c164 404 qemu_mips \
2a61eff6
SR
405 vct_platinum \
406 vct_platinum_small \
407 vct_platinum_onenand \
408 vct_platinum_onenand_small \
409 vct_platinumavc \
410 vct_platinumavc_small \
411 vct_platinumavc_onenand \
412 vct_platinumavc_onenand_small \
413 vct_premium \
414 vct_premium_small \
415 vct_premium_onenand \
416 vct_premium_onenand_small \
fb56579f 417"
c021880a 418
fb56579f
KP
419LIST_au1xx0=" \
420 dbau1000 \
421 dbau1100 \
422 dbau1500 \
423 dbau1550 \
fb56579f 424"
5da627a4 425
fb56579f
KP
426LIST_mips=" \
427 ${LIST_mips4kc} \
428 ${LIST_mips5kc} \
429 ${LIST_au1xx0} \
430"
c021880a 431
b62bdffb
WD
432#########################################################################
433## MIPS Systems (little endian)
434#########################################################################
435
92b09095 436LIST_xburst_el=" \
3c945542
XL
437 qi_lb60 \
438"
b62bdffb 439
fb56579f
KP
440LIST_au1xx0_el=" \
441 dbau1550_el \
b09258c5 442 pb1000 \
fb56579f 443"
fb56579f 444LIST_mips_el=" \
92b09095 445 ${LIST_xburst_el} \
fb56579f
KP
446 ${LIST_au1xx0_el} \
447"
deddf5d2
SK
448#########################################################################
449## OpenRISC Systems
450#########################################################################
451
452LIST_openrisc="$(boards_by_arch openrisc)"
b62bdffb 453
7a8e9bed 454#########################################################################
fea25720 455## x86 Systems
7a8e9bed
WD
456#########################################################################
457
fea25720 458LIST_x86="$(boards_by_arch x86)"
7a8e9bed 459
5c952cf0
WD
460#########################################################################
461## Nios-II Systems
462#########################################################################
463
4827d067 464LIST_nios2="$(boards_by_arch nios2)"
5c952cf0 465
857cad37
WD
466#########################################################################
467## MicroBlaze Systems
468#########################################################################
469
9ec49f8f 470LIST_microblaze="$(boards_by_arch microblaze)"
857cad37 471
f8c3b4f3
ZL
472#########################################################################
473## ColdFire Systems
474#########################################################################
475
cce5d210 476LIST_m68k="$(boards_by_arch m68k)"
c13f47b0 477LIST_coldfire=${LIST_m68k}
f8c3b4f3 478
6ccec449
WD
479#########################################################################
480## AVR32 Systems
481#########################################################################
482
9ec49f8f 483LIST_avr32="$(boards_by_arch avr32)"
6ccec449 484
ef26a08f
AL
485#########################################################################
486## Blackfin Systems
487#########################################################################
488
36cf8cb4 489LIST_blackfin="$(boards_by_arch blackfin)"
ef26a08f 490
c7144373
JCPV
491#########################################################################
492## SH Systems
493#########################################################################
494
e0f0e527 495LIST_sh2="$(boards_by_cpu sh2)"
3771c69d 496LIST_sh3="$(boards_by_cpu sh3)"
03626be3 497LIST_sh4="$(boards_by_cpu sh4)"
d9a42c0a 498
03626be3 499LIST_sh="$(boards_by_arch sh)"
c7144373 500
c2f02da2
DH
501#########################################################################
502## SPARC Systems
503#########################################################################
504
9ec49f8f 505LIST_sparc="$(boards_by_arch sparc)"
7ebf7443 506
5f1719c1
ML
507#########################################################################
508## NDS32 Systems
509#########################################################################
510
511LIST_nds32="$(boards_by_arch nds32)"
512
7ebf7443
WD
513#-----------------------------------------------------------------------
514
9b96c6b1
MV
515get_target_location() {
516 local target=$1
517 local BOARD_NAME=""
518 local CONFIG_NAME=""
519 local board=""
520 local vendor=""
521
522 # Automatic mode
523 local line=`egrep -i "^[[:space:]]*${target}[[:space:]]" boards.cfg`
524
525 if [ -z "${line}" ] ; then echo "" ; return ; fi
526
527 set ${line}
528
529 # add default board name if needed
530 [ $# = 3 ] && set ${line} ${1}
531
532 CONFIG_NAME="${1%_config}"
533
534 [ "${BOARD_NAME}" ] || BOARD_NAME="${1%_config}"
535
536 if [ "$4" = "-" ] ; then
537 board=${BOARD_NAME}
538 else
539 board="$4"
540 fi
541
542 [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
543 [ $# -gt 6 ] && [ "$7" != "-" ] && {
544 tmp="${7%:*}"
545 if [ "$tmp" ] ; then
546 CONFIG_NAME="$tmp"
547 fi
548 }
549
550 # Assign board directory to BOARDIR variable
551 if [ -z "${vendor}" ] ; then
552 BOARDDIR=${board}
553 else
554 BOARDDIR=${vendor}/${board}
555 fi
556
557 echo "${CONFIG_NAME}:${BOARDDIR}"
558}
559
560get_target_maintainers() {
561 local name=`echo $1 | cut -d : -f 1`
562
563 if ! grep -qsi "[[:blank:]]${name}[[:blank:]]" MAINTAINERS ; then
564 echo ""
565 return ;
566 fi
567
568 local line=`tac MAINTAINERS | grep -ni "[[:blank:]]${name}[[:blank:]]" | cut -d : -f 1`
569 local mail=`tac MAINTAINERS | tail -n +${line} | \
570 sed -n ":start /.*@.*/ { b mail } ; n ; b start ; :mail /.*@.*/ { p ; n ; b mail } ; q" | \
571 sed "s/^.*<//;s/>.*$//"`
572 echo "$mail"
573}
574
575list_target() {
576 if [ "$PRINT_MAINTS" != 'y' ] ; then
577 echo "$1"
578 return
579 fi
580
581 echo -n "$1:"
582
583 local loc=`get_target_location $1`
584
585 if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
586
587 local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
588
589 if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
590
591 local dir=`echo ${loc} | cut -d ":" -f 2`
592 local cfg=`echo ${loc} | cut -d ":" -f 1`
593 local git_result=`git log --format=%aE board/${dir} \
594 include/configs/${cfg}.h | grep "@"`
595 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
596 head -n 3`
597 local git_result_top=`echo ${git_result} | tr " " "\n" | \
598 sort | uniq -c | sort -nr | head -n 3 | \
599 sed "s/^ \+[0-9]\+ \+//"`
600
601 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
602 sort -u | tr "\n" " " | sed "s/ $//" ;
603 else
604 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
605 sed "s/ $//" ;
606 fi
607
608 echo ""
609}
610
f588bb03
AF
611# Each finished build will have a file called ${donep}${n},
612# where n is the index of the build. Each build
613# we've already noted as finished will have ${skipp}${n}.
614# The code managing the build process will use this information
615# to ensure that only BUILD_NBUILDS builds are in flight at once
616donep="${LOG_DIR}/._done_"
617skipp="${LOG_DIR}/._skip_"
618
c97d59cb
JH
619build_target_killed() {
620 echo "Aborted $target build."
621 # Remove the logs for this board since it was aborted
622 rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
623 exit
624}
625
7ebf7443
WD
626build_target() {
627 target=$1
f588bb03
AF
628 build_idx=$2
629
f50bf50d
AF
630 if [ "$ONLY_LIST" == 'y' ] ; then
631 list_target ${target}
632 return
633 fi
634
f588bb03
AF
635 if [ $BUILD_MANY == 1 ] ; then
636 output_dir="${OUTPUT_PREFIX}/${target}"
637 mkdir -p "${output_dir}"
c97d59cb 638 trap build_target_killed TERM
f588bb03
AF
639 else
640 output_dir="${OUTPUT_PREFIX}"
641 fi
642
643 export BUILD_DIR="${output_dir}"
7ebf7443
WD
644
645 ${MAKE} distclean >/dev/null
d70d8ccc 646 ${MAKE} -s ${target}_config
f9328639 647
33f336d5 648 ${MAKE} ${JOBS} ${CHECK} all \
f588bb03 649 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
f2352877
PT
650
651 # Check for 'make' errors
652 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
653 RC=1
654 fi
655
f588bb03 656 if [ $BUILD_MANY == 1 ] ; then
c97d59cb
JH
657 trap - TERM
658
ed296d20 659 ${MAKE} -s tidy
f588bb03
AF
660
661 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
b86a475c 662 cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
f588bb03
AF
663 else
664 rm ${LOG_DIR}/${target}.ERR
665 fi
40a28f08 666 else
f588bb03 667 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
b86a475c
JH
668 if grep -iw error ${LOG_DIR}/${target}.ERR ; then
669 : $(( ERR_CNT += 1 ))
670 ERR_LIST="${ERR_LIST} $target"
671 else
672 : $(( WRN_CNT += 1 ))
673 WRN_LIST="${WRN_LIST} $target"
674 fi
f588bb03
AF
675 else
676 rm ${LOG_DIR}/${target}.ERR
677 fi
40a28f08
PT
678 fi
679
f588bb03
AF
680 OBJS=${output_dir}/u-boot
681 if [ -e ${output_dir}/spl/u-boot-spl ]; then
682 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
0c185696
SW
683 fi
684
685 ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
f588bb03
AF
686
687 [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
688
f588bb03 689 touch "${donep}${build_idx}"
7ebf7443 690}
f588bb03
AF
691
692manage_builds() {
693 search_idx=${OLDEST_IDX}
f50bf50d
AF
694 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
695
f588bb03
AF
696 while true; do
697 if [ -e "${donep}${search_idx}" ] ; then
f588bb03
AF
698 : $(( CURRENT_CNT-- ))
699 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
700 : $(( OLDEST_IDX++ ))
701
702 # Only want to count it once
703 rm -f "${donep}${search_idx}"
704 touch "${skipp}${search_idx}"
705 elif [ -e "${skipp}${search_idx}" ] ; then
706 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
707 : $(( OLDEST_IDX++ ))
708 fi
f588bb03
AF
709 : $(( search_idx++ ))
710 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
f588bb03
AF
711 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
712 search_idx=${OLDEST_IDX}
713 sleep 1
714 else
715 break
716 fi
717 fi
718 done
719}
720
9ec49f8f
MF
721build_targets() {
722 for t in "$@" ; do
723 # If a LIST_xxx var exists, use it. But avoid variable
724 # expansion in the eval when a board name contains certain
725 # characters that the shell interprets.
726 case ${t} in
727 *[-+=]*) list= ;;
728 *) list=$(eval echo '${LIST_'$t'}') ;;
729 esac
730 if [ -n "${list}" ] ; then
731 build_targets ${list}
732 else
f588bb03
AF
733 : $((TOTAL_CNT += 1))
734 : $((CURRENT_CNT += 1))
735 rm -f "${donep}${TOTAL_CNT}"
736 rm -f "${skipp}${TOTAL_CNT}"
b594bd6a
JH
737 if [ $BUILD_MANY == 1 ] ; then
738 build_target ${t} ${TOTAL_CNT} &
739 else
c97d59cb 740 CUR_TGT="${t}"
b594bd6a 741 build_target ${t} ${TOTAL_CNT}
c97d59cb 742 CUR_TGT=''
b594bd6a 743 fi
f588bb03
AF
744 fi
745
746 # We maintain a running count of all the builds we have done.
747 # Each finished build will have a file called ${donep}${n},
748 # where n is the index of the build. Each build
749 # we've already noted as finished will have ${skipp}${n}.
750 # We track the current index via TOTAL_CNT, and the oldest
751 # index. When we exceed the maximum number of parallel builds,
752 # We look from oldest to current for builds that have completed,
753 # and update the current count and oldest index as appropriate.
754 # If we've gone through the entire list, wait a second, and
755 # reprocess the entire list until we find a build that has
756 # completed
757 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
758 manage_builds
9ec49f8f
MF
759 fi
760 done
761}
7ebf7443
WD
762
763#-----------------------------------------------------------------------
764
f50bf50d 765kill_children() {
c97d59cb
JH
766 local pgid=`ps -p $$ --no-headers -o "%r" | tr -d ' '`
767 local children=`pgrep -g $pgid | grep -v $$ | grep -v $pgid`
768
769 kill $children 2> /dev/null
770 wait $children 2> /dev/null
f50bf50d
AF
771
772 exit
773}
774
40a28f08 775print_stats() {
7f79c6f2 776 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
f588bb03 777
c97d59cb
JH
778 # Only count boards that completed
779 : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
780
f588bb03
AF
781 rm -f ${donep}* ${skipp}*
782
783 if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
033220e7 784 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
b86a475c
JH
785 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
786 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
033220e7 787 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
b86a475c
JH
788 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
789 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
c97d59cb
JH
790 else
791 # Remove the logs for any board that was interrupted
792 rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
f588bb03
AF
793 fi
794
40a28f08
PT
795 echo ""
796 echo "--------------------- SUMMARY ----------------------------"
797 echo "Boards compiled: ${TOTAL_CNT}"
798 if [ ${ERR_CNT} -gt 0 ] ; then
b86a475c
JH
799 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
800 fi
801 if [ ${WRN_CNT} -gt 0 ] ; then
802 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
40a28f08
PT
803 fi
804 echo "----------------------------------------------------------"
f2352877 805
f50bf50d 806 if [ $BUILD_MANY == 1 ] ; then
c97d59cb 807 kill_children
f50bf50d
AF
808 fi
809
f2352877 810 exit $RC
40a28f08 811}
7ebf7443 812
40a28f08 813#-----------------------------------------------------------------------
9ec49f8f 814
0777eafb
WD
815# Build target groups selected by options, plus any command line args
816set -- ${SELECTED} "$@"
817# run PowerPC by default
9ec49f8f 818[ $# = 0 ] && set -- powerpc
9ec49f8f 819build_targets "$@"
f588bb03 820wait
This page took 0.381002 seconds and 4 git commands to generate.